enum SELECT{
    //% block="前"
    1,
    //% block="后"
    2,
    //% block="右"
    3,
    //% block="左"
    4,
    //% block="上"
    6,
    //% block="下"
    5

}

enum Motor{
    //% block="MA"
    1,
    //% block="MB"
    2
}
enum Dir{
    //% block="正转"
    HIGH,
    //% block="反转"
    LOW
}

enum TM1637D{
    //% block="清屏"
    clear,
    //% block="闪烁"
    blink,
    //% block="开"
    on,
    //% block="关"
    off,
}
enum COLON{
    //% block="开"
    true,
    //% block="关"
    false
}

enum MP3TYPE{
    //% block="播放"
    mp3_play,
    //% block="暂停"
    mp3_pause,
    //% block="停止"
    mp3_stop,
    //% block="下一首"
    mp3_next_song,
    //% block="上一首"
    mp3_last_song,
    //% block="音量加"
    mp3_vol_up,
    //% block="音量减"
    mp3_vol_dn

}

enum MP3MODEL{
    //% block="全部循环"
    mp3_loop_play,
    //% block="单曲循环"
    mp3_loop_single_play,
    //% block="单曲停止"
    mp3_single_stop,
    //% block="随机播放"
    mp3_random_paly,
    //% block="顺序播放"
    mp3_order_play

}

enum JYPE{
    //% block="X"
    x,
    //% block="Y"
    y
}

enum COLOR{
    //% block="白"
    1,
    //% block="黑"
    2,
    //% block="红"
    7,
    //% block="绿"
    8,
    //% block="蓝"
    9,
    //% block="黄"
    3,
    //% block="紫"
    4,
    //% block="棕"
    5,
    //% block="靛"
    6
   

}

//% color="#9370DB" iconWidth=50 iconHeight=40
namespace MakerHardware {
   
    //% block="电机 [MOTOR] 方向[DIR] 速度 [SPEED]" blockType="command" board="arduino"
    //% MOTOR.shadow="dropdown" MOTOR.options="Motor" MOTOR.defl="Motor.MA"
    //% DIR.shadow="dropdown" DIR.options="Dir" DIR.defl="Dir.正转"
    //% SPEED.shadow="range" SPEED.params.min=0    SPEED.params.max=255    SPEED.defl=200
    export function MoterControl(parameter: any, block: any){
    
        let motor = parameter.MOTOR.code;
        let dir = parameter.DIR.code;
        let speed = parameter.SPEED.code;
        if(motor == '1'){
            Generator.addCode(`digitalWrite(7, ${dir});\t\n  analogWrite(5, ${speed});`);
        }else{
            Generator.addCode(`digitalWrite(8, ${dir});\t\n  analogWrite(6, ${speed});`);
        }
    
        

    }

//% block="---"
export function noteSep6() {

}

   //% block="刷新MPU6050数据" blockType="command"
   export function MPU6050INIT(parameter: any, block: any) {
    Generator.addInclude('I2Cdevinclude', '#include "I2Cdev.h"');
    Generator.addInclude('MPU6050include', '#include "MPU6050_6Axis_MotionApps20.h"');
    Generator.addObject(`mpu6050obj`, `MPU6050`, `mpu;`);
    Generator.addObject(`mpu6050obj1`, `int16_t`, `gx, gy, gz, ax, ay, az,mpustate;`);
    Generator.addObject(`mpu6050obj2`, `float`, `Acc_x,Acc_y,Acc_z;`);
    Generator.addSetup(`wirebegin`, `Wire.begin();`);
    Generator.addSetup(`mpu6050SETUP`, ` mpu.initialize();`);
    Generator.addCode(`mpu.getMotion6(&ax, &ay, &az, &gx, &gy, &gz); `);
    Generator.addCode(`//去掉偏移量
  Acc_x = ax-580;Acc_y = ay+120;Acc_z = az+1584;

  //换算成国标单位m/s2与rad/s
  Acc_x = Acc_x/16384*9.8;
  Acc_y = Acc_y/16384*9.8;
  Acc_z = Acc_z/16384*9.8; `);
}

//% block="MPU6050 姿态向 [op]" blockType="boolean"
//% op.shadow="dropdown" op.options="SELECT" op.defl="SELECT.X轴"
export function MPU6050ACCEL(parameter: any, block: any) {
    let Op = parameter.op.code;
    Generator.addObject(`mpu6050Data`, `int`, `DataProcessing()
{  
    if(Acc_x <-6){
    mpustate=1 ;//前
    }else if(Acc_x > 5){
    mpustate = 2; // 后
    }else if(Acc_y <-7){
    mpustate=3 ;//右
    }else if(Acc_y > 7){
    mpustate = 4; // 左
    }else if(Acc_z <-8){
    mpustate=5;//下
    }else if(Acc_z > 8){
    mpustate = 6; // 上
    } 
    return mpustate;
}`);
    Generator.addCode(`DataProcessing()==${Op}`);

}
//% block="---"
export function noteSep5() {

}
//% block="读取矩阵键盘[PIN]的值" blockType="command"
//% PIN.shadow="dropdown" PIN.options="PIN_AnalogRead" 
export function keyPad(parameter: any, block: any){
   
    let pin = parameter.PIN.code;
    Generator.addObject("KEYpadObject","float",`kpValue;`);
    Generator.addCode(`kpValue = map(analogRead(${pin}), 0, 600, 0, 100);`);
    

}
//% block="矩阵键盘 [PIN]的是否被按下" blockType="boolean"
//% PIN.shadow="dropdown" PIN.options="PIN_AnalogRead" 
export function keyPadValue(parameter: any, block: any){
   
    let pin = parameter.PIN.code;

    Generator.addCode(`kpValue == ${pin}`);
    

}
//% block="---"
export function noteSep4() {

}

//% block="读取MQ2 [PIN]的值" blockType="reporter"
//% PIN.shadow="dropdown" PIN.options="PIN_AnalogRead" 
export function MQ2READ(parameter: any, block: any){
   
    let pin = parameter.PIN.code;

    Generator.addCode(`analogRead(${pin})`);
    

}
//% block="---"
export function noteSep7() {

}
//% block="读取摇杆[PIN][JYPE]轴的值" blockType="reporter"
//% PIN.shadow="dropdown" PIN.options="PIN_AnalogRead" 
//% JYPE.shadow="dropdown" JYPE.options="JYPE" 
export function JoyStick(parameter: any, block: any){
   
    let pin = parameter.PIN.code;

    Generator.addCode(`analogRead(${pin})`);
    
}
//% block="摇杆[PIN]Z轴被按下" blockType="boolean"
//% PIN.shadow="dropdown" PIN.options="PIN_DigitalRead" 
export function JoyStickButton(parameter: any, block: any){
   
    let pin = parameter.PIN.code;

    Generator.addCode(`digitalRead(${pin}) == 0`);
    
}
 //% block="---"
 export function noteSep3() {

}
//% block="MAX7219点阵屏初始化DIN[DIN] CS[CS] CLK[CLK] " blockType="command"
//% DIN.shadow="dropdown" DIN.options="PIN_DigitalWrite" DIN.defl="PIN_DigitalWrite.default_MAX7219_DIN"
//% CS.shadow="dropdown" CS.options="PIN_DigitalWrite" CS.defl="PIN_DigitalWrite.default_MAX7219_CS"
//% CLK.shadow="dropdown" CLK.options="PIN_DigitalWrite" CLK.defl="PIN_DigitalWrite.default_MAX7219_CLK"
export function MAX7219(parameter: any, block: any){
   
    let din = parameter.DIN.code;
    let cs = parameter.CS.code;
    let clk = parameter.CLK.code;

    Generator.addInclude("MAX7219Include","#include <DFRobot_LedControl.h>");
    Generator.addObject("MAX7219Object","DFRobot_LedControl",`max7219;`);
    Generator.addSetup("MAX7219Init",`max7219.begin(${din},${clk},${cs});`);
    

}
{}
    //% extenralFunc
    export function getBuiltinFunc_() {
        return [
            {matrix: "0000000001100110011001100000000000000000001001000001100000000000"},
            {matrix: "0000000001000010111001111110011101000010000000000001100000100100"},
            {matrix: "0000000000111100001001000010010000100100011011000110110000000000"},
            {matrix: "0000000000001000000011100000101000001000001110000011100000000000"}
            
        ]
    }
export function getRandomAlphaNum(len) {
    var rdmString = "";
    for (; rdmString.length < len; rdmString += Math.random().toString(36).substr(2));
    return rdmString.substr(0, len);
}

//% block="MAX7219点阵屏定义[MT] " blockType="command"
//% MT.shadow="matrix" MT.params.row=8 MT.params.column=8 MT.defl="0000000001100110011001100000000000000000001001000001100000000000"
//% MT.params.builtinFunc="getBuiltinFunc_"

export function MAX7219IintDisplay(parameter: any, block: any){
   
    let mt = parameter.MT.code;

    let sts = "B";
    
    var rdmString = "M";
    for (; rdmString.length < 8; rdmString += Math.random().toString(36).substr(2));
    rdmString= rdmString.substr(0, 8)
//    Generator.addCode(`const uint8_t ${rdmString}[][8]={`);

    for(let i=0;i<8;i++){
        let st = mt.substr(i*8,8);
    
        for(let j=0;j<8;j++){
            sts = sts+st.substr(j,1);
        }
        if(i==7){
            sts = sts;
        }else{
            sts = sts + ",B";
        }
        
    }
    
   // Generator.addObject("MAX7219DaObject","",`};`);
//    Generator.addCode(`};`);
  
  Generator.addObject(`MAX7219${rdmString}Object`,"const uint8_t",`${rdmString}[][8] = {\n\t{${sts}}\n};`);
  Generator.addCode(`max7219.show(${rdmString}[0]);`); 
}



 //% block="---"
 export function noteSep2() {

}
//% block="颜色传感器初始化 " blockType="command"

export function TCS34725(parameter: any, block: any){
  

    Generator.addInclude("TCS34725Include","#include <DFRobot_TCS34725.h>");
    Generator.addObject("TCS34725Object","DFRobot_TCS34725",`tcs34725;`);
    Generator.addSetup("TCS34725Init",`tcs34725.begin();`);
}

//% block="当颜色传感器识别为[COLOR]色 " blockType="boolean"
//% COLOR.shadow="dropdown" COLOR.options="COLOR" DIN.defl="COLOR.红色"
export function TCS34725Color(parameter: any, block: any){
  
    let color = parameter.COLOR.code;
    Generator.addObject(`TCS34725Colorinit`,`int`,`colortemp;`);
    Generator.addObject(`TCS34725ColorOb`, `int`, `ColorRecognition(){
        int r = tcs34725.getRedToGamma();
        int g = tcs34725.getGreenToGamma();
        int b = tcs34725.getBlueToGamma();
        if(r > 2 && r <10 && g>10 && g < 18 && b>26 && b<34){
          colortemp = 1; //黑
        }else if(r > 0 && r <7 && g>10 && g < 18 && b>35 && b< 44){
          colortemp = 2; //白
        }else if(r > 17 && r <25 && g>18 && g < 26 && b>0 && b< 7){
          colortemp = 3; // 黄
        }else if(r > 4 && r <12 && g>3 && g < 11 && b>37 && b< 45){
          colortemp = 4; //紫
        }else if(r > 8 && r <16 && g>10 && g < 18 && b>14 && b< 22){
          colortemp = 5; // 棕色
        }else if(r > 0 && r <5 && g>10 && g < 18 && b>51 && b< 59){
          colortemp = 6; //靛
        }else if(r > 43 && r <55 && g>0 && g < 10  && b>7 && b< 15){
          colortemp = 7; //红
        }else if(r > 0 && r <5 && g>25 && g < 33 && b>20 && b< 28){
          colortemp = 8; // 绿
        }else if(r > 0 && r <5 && g>5 && g < 14 && b>70 && b< 80){
          colortemp = 9; // 蓝
        }
        return colortemp;
      }`);
   
    Generator.addCode(`ColorRecognition() == ${color}`);
}
 //% block="---"
 export function noteSep1() {

}
//% block="数码管初始化 SCL[SCL]  SDA[SDA]" blockType="command"
//% SCL.shadow="dropdown" SCL.options="PIN_DigitalWrite" SCL.defl="PIN_DigitalWrite.default_TM1637_SCL"
//% SDA.shadow="dropdown" SDA.options="PIN_DigitalWrite" SDA.defl="PIN_DigitalWrite.default_TM1637_SDA"
export function TM1637(parameter: any, block: any){
    let scl = parameter.SCL.code;
    let sda = parameter.SDA.code;

    Generator.addInclude("TM1637Include","#include <SevenSegmentTM1637.h>");
    Generator.addInclude("TM1637IncludeExtended","#include <SevenSegmentExtended.h>");
    Generator.addObject("TM1637Object","SevenSegmentExtended",`tm1637(${scl},${sda});`);
    Generator.addSetup("TM1637Init",`tm1637.begin();`);
}

//% block="数码管[MODEL]" blockType="command"
//% MODEL.shadow="dropdown" MODEL.options="TM1637D" MODEL.defl="TM1637D.清屏"
export function TM1637SET(parameter: any, block: any){
    let model = parameter.MODEL.code;

    Generator.addCode(`tm1637.${model}();`);
}

//% block="数码管[MODEL]" blockType="command"
//% MODEL.shadow="dropdown" MODEL.options="TM1637D" MODEL.defl="TM1637D.清屏"
export function TM1637SET(parameter: any, block: any){
    let model = parameter.MODEL.code;

    Generator.addCode(`tm1637.${model}();`);
}

//% block="数码管设置亮度[LIGHT]" blockType="command"
//% LIGHT.shadow="range" LIGHT.params.min=0    LIGHT.params.max=100   LIGHT.defl=50
export function TM1637Light(parameter: any, block: any){
    let light = parameter.LIGHT.code;

    Generator.addCode(`tm1637.setBacklight(${light});`);
}

//% block="数码管显示[MESSAGE]" blockType="command"
//% MESSAGE.shadow="String" MESSAGE.defl="2022"
export function TM1637DISPALY(parameter: any, block: any){
    let msg = parameter.MESSAGE.code;

    Generator.addCode(`tm1637.print(${msg});`);
}

 //% block="数码管显示时间 [TIME]:[MIN] COLON [COLON]" blockType="command"
//% TIME.shadow="range" TIME.params.min=0 TIME.params.max=23 TIME.defl=12
//% MIN.shadow="range" MIN.params.min=0 MIN.params.max=59 MIN.defl=30
//% COLON.shadow="dropdownRound" COLON.options="COLON"
export function TM1637DisplayTime(parameter:any,block: any){
    let tm=parameter.TIME.code;
    let min=parameter.MIN.code;
    let col=parameter.COLON.code;
    
    Generator.addCode(`tm1637.printTime(${tm},${min},${col});`)
}
    //% block="---"
    export function noteSep() {

    }
//% block="MP3模块 初始化 RX[RX] TX[TX] 声音[SOUND]" blockType="command"
//% RX.shadow="dropdown" RX.options="PIN_DigitalWrite" RX.defl="PIN_DigitalWrite.default_MP3INIT_RX"
//% TX.shadow="dropdown" TX.options="PIN_DigitalWrite" TX.defl="PIN_DigitalWrite.default_MP3INIT_TX"
//% SOUND.shadow="range" SOUND.params.min=0    SOUND.params.max=100    SOUND.defl=50
export function MP3INIT(parameter: any, block: any){
    let rx = parameter.RX.code;
    let tx = parameter.TX.code;
    let sound = parameter.SOUND.code;

    Generator.addInclude("MP3Include","#include <SoftwareSerial.h>");
    Generator.addObject("MP3Object","SoftwareSerial",`mp3(${rx},${tx});`);
    Generator.addObject("MP3VObject","void",`mp3_volume(uint8_t level){

        uint8_t sum = level + 0xBE;
    
        uint8_t volume[5] = {0xAA,0x13,0x01,level,sum};
    
        mp3.write(volume,5);
    
    }`);
    Generator.addSetup("MP3Init",`mp3.begin(9600);`);
    Generator.addSetup("MP3SETV",`mp3_volume(${sound});`);
}



//% block="MP3模块 播放第[NUM]首音乐" blockType="command"
//% NUM.shadow="number" NUM.defl=1
export function MP3PalyControl(parameter: any, block: any){

    let num = parameter.NUM.code;

    Generator.addObject("MP3PCObject","void",`mp3_play_chapter(uint16_t chapter){

        uint8_t chapter_h = chapter>>8;
    
        uint8_t chapter_l = chapter;
    
        uint8_t sum = 0xB3 + chapter_h + chapter_l;
    
        uint8_t play_chapter[6] = {0xAA,0x07,0x02,chapter_h,chapter_l,sum};
    
        mp3.write(play_chapter,6);
    
    }`);
    Generator.addCode(`mp3_play_chapter(${num});`);
}

//% block="MP3模块 播放控制为 [Type]" blockType="command"
//% Type.shadow="dropdown" Type.options="MP3TYPE" Type.defl="MP3TYPE.播放"
export function MP3PalyType(parameter: any, block: any){

    let type = parameter.Type.code;

    Generator.addObject("MP3PTObject","void",`mp3_play(){

        unsigned char play[4] = {0xAA,0x02,0x00,0xAC};
    
        mp3.write(play,4);
    
    }
    
void mp3_next_song(){
    
    unsigned char play[4] = {0xAA,0x06,0x00,0xB0};

    mp3.write(play,4);

}
    
void mp3_last_song(){
    
    unsigned char play[4] = {0xAA,0x05,0x00,0xAF};

    mp3.write(play,4);

}
    
void mp3_vol_up(){
    
    unsigned char play[4] = {0xAA,0x14,0x00,0xBE};

    mp3.write(play,4);

}
    
void mp3_vol_dn(){
    
    unsigned char play[4] = {0xAA,0x15,0x00,0xBF};

    mp3.write(play,4);

}
    
void mp3_stop(){

    unsigned char play[4] = {0xAA,0x04,0x00,0xAE};

    mp3.write(play,4);

}
    
void mp3_pause(){

    unsigned char play[4] = {0xAA,0x03,0x00,0xAD};

    mp3.write(play,4);

}`);
    Generator.addCode(`${type}();`);
}

//% block="MP3模块 播放模式为 [MODEL]" blockType="command"
//% MODEL.shadow="dropdown" MODEL.options="MP3MODEL" MODEL.defl="MP3MODEL.全部循环"
export function MP3PalyModel(parameter: any, block: any){

    let model = parameter.MODEL.code;

    Generator.addObject("MP3PMObject","void",`mp3_loop_play(){

        unsigned char volume[5] = {0xAA,0x18,0x01,0x00,0xC3};
    
        mp3.write(volume,5);
    
    }
    
void mp3_loop_single_play(){

    unsigned char volume[5] = {0xAA,0x18,0x01,0x01,0xC4};

    mp3.write(volume,5);

}

void mp3_single_stop(){

    unsigned char volume[5] = {0xAA,0x18,0x01,0x05,0xC5};

    mp3.write(volume,5);

}

void mp3_random_play(){

    unsigned char volume[5] = {0xAA,0x18,0x01,0x03,0xC6};

    mp3.write(volume,5);

}

void mp3_order_play(){

    unsigned char volume[5] = {0xAA,0x18,0x01,0x07,0xCA};

    mp3.write(volume,5);

}`);
    Generator.addCode(`${model}();`);
}
//% block="MP3模块 播放距离[DIST]" blockType="command"
//% DIST.shadow="number" DIST.defl=123
export function MP3PalyDist(parameter: any, block: any){

    let dist = parameter.DIST.code;

Generator.addObject("MP3PDObject","unsigned char",` mp3_SumCheck(unsigned char *buf, unsigned char len){

    unsigned char sum = 0;

    for(unsigned char i=0;i<len;i++){

        sum = sum + *buf;

            buf++;

        }

    return sum;

}
    
unsigned char mp3_voice_table[30]={0x34,0x35,0x33,0x36,0x33,0x37,0x33,0x38,0x33,0x39,0x34,0x30,0x34,0x31,0x34,0x32,0x34,0x33,0x34,0x34,0x33,0x33,0x33,0x34,0x33,0x35,0x33,0x30,0x31,0x36};

void mp3_playDistance(float s){

    int num = s*10;

    unsigned char Bit1 = num/1000;

    if (Bit1 > 9)return;

    num = num % 1000;unsigned char Bit2 = num/100;num = num % 100;unsigned char Bit3 = num/10;num = num % 10;unsigned char Bit4 = num;

    unsigned char play[20];

    play[0]=0xAA;//HEAD

    play[1]=0x1B;//CMD

    int index = 3;

    if(Bit1){

        play[index++]=mp3_voice_table[Bit1*2];

        play[index++]=mp3_voice_table[Bit1*2+1];

        play[index++]=mp3_voice_table[22];

        play[index++]=mp3_voice_table[23];

    }

    if(Bit2){

        play[index++]=mp3_voice_table[Bit2*2];

        play[index++]=mp3_voice_table[Bit2*2+1];

        play[index++]=mp3_voice_table[24];

        play[index++]=mp3_voice_table[25];

    }

    if(!((Bit3 == 0) && (Bit2 == 0) && (Bit1 > 0))){

        play[index++]=mp3_voice_table[Bit3*2];

        play[index++]=mp3_voice_table[Bit3*2+1];

    }

    if(Bit4){

        play[index++]=mp3_voice_table[26];

        play[index++]=mp3_voice_table[27];

        play[index++]=mp3_voice_table[Bit4*2];

        play[index++]=mp3_voice_table[Bit4*2+1];

    }

        play[index++]=mp3_voice_table[28];

        play[index++]=mp3_voice_table[29];

    play[2]=index-3;

    play[index++]=mp3_SumCheck(play,play[2]+4-1);

    mp3.write(play,play[2]+4);

}`);
    Generator.addCode(`mp3_playDistance(${dist});`);
}



}
